﻿
namespace Validation
{

    /// <summary>
    /// Axes settings for:
    /// - Actual minimum and maximum of the axis.
    /// - Actual display minimum and maximum (Like a display range) of the axis.
    /// </summary>
    public class AxisSettingsModel : PropertyChangedNotifier
    {
        #region Members
        private double actualMinimumDisplayValue;

        private double actualMaximumDisplayValue;

        private double actualMinimumValue;

        private double actualMaximumValue;
        #endregion

        /// <summary>
        /// Actual minimum display
        /// </summary>
        public double ActualMinimumDisplayValue
        {
            get
            {
                return this.actualMinimumDisplayValue;
            }
            set
            {
                if (value != this.actualMinimumDisplayValue)
                {
                    this.actualMinimumDisplayValue = value;

                    this.OnPropertyChanged("ActualMinimumDisplayValue");
                }
            }
        }

        /// <summary>
        /// Actual maximum display value
        /// </summary>
        public double ActualMaximumDisplayValue
        {
            get
            {
                return this.actualMaximumDisplayValue;
            }

            set
            {
                if (this.actualMaximumDisplayValue != value)
                {
                    this.actualMaximumDisplayValue = value;
                    this.OnPropertyChanged("ActualMaximumDisplayValue");
                }
            }
        }

        /// <summary>
        /// Actual minimum value
        /// </summary>
        public double ActualMinimumValue
        {
            get
            {
                return this.actualMinimumValue;
            }

            set
            {
                if (this.actualMinimumValue != value)
                {
                    this.actualMinimumValue = value;
                    
                    this.ActualMinimumDisplayValue = value;
                    
                    this.OnPropertyChanged("ActualMinimumValue");
                }
            }
        }

        /// <summary>
        /// Actual maximum value
        /// </summary>
        public double ActualMaximumValue
        {
            get
            {
                return this.actualMaximumValue;
            }

            set
            {
                if (this.actualMaximumValue != value)
                {
                    this.actualMaximumValue = value;

                    this.ActualMaximumDisplayValue = value;

                    this.OnPropertyChanged("ActualMaximumValue");
                }
            }
        }
    }
}
